% $Id: Testing.oz,v 1.3 2006/09/26 09:42:46 leavens Exp leavens $
%
% Assertion and testing procedures for Oz.
%
% AUTHOR: Gary T. Leavens

functor $
import
   System(showInfo)
export
   assert: Assert
   assume: Assume
   start: StartTesting
   test: Test
define
   %% Assert that the argument is true.
   proc {Assert B}
      if {Not B}
      then raise assertionFailed(debug:unit) end
      end
   end

   %% Mark an assumption that the argument is true.
   proc {Assume B}
      {Assert B}
   end

   %% Print a newline and a message that testing is beginning.
   proc {StartTesting Name}
      {System.showInfo ""}
      {System.showInfo 'Testing ' # Name # '...'}
   end

   %% Test if Actual == Expected.
   %% If so, print a message, otherwise throw an exception.
   proc {Test Actual Connective Expected}
      if Actual == Expected
      then {System.showInfo
            {Value.toVirtualString Actual 5 10}
            # ' ' # Connective # ' '
            # {Value.toVirtualString Expected 5 10}}
      else raise testFailed(actual:Actual
                            connective:Connective
			    expected:Expected
			    debug:unit)
           end
      end
   end
end
